您的位置: 首页 > 软件教程 > C++教程专题 > C++抛出异常技巧讲解

C++抛出异常技巧讲解

8.5分
出处:网络 时间:2012-04-05

您可能感兴趣的话题: C++  

核心提示:C++语言与其他编程语言一样,其中也包含有关于异常的处理。

  C++语言与其他编程语言一样,其中也包含有关于异常的处理。我们在这里将会为大家详细讲解一下有关C++抛出异常的实现方法,及异常的应用方式。希望大家可以从中获得些帮助,以提高对此的理解程度。

  C++抛出异常(也称为抛弃异常)即检测是否产生异常,在C++中,其采用throw语句来实现,如果检测到产生异常,则抛出异常。该语句的格式为:

  throw 表达式;

  如果在try语句块的程序段中(包括在其中调用的函数)发现了异常,且抛弃了该异常,则这个异常就可以被try语句块后的某个catch语句所捕获并处理,捕获和处理的条件是被抛弃的异常的类型与catch语句的异常类型相匹配。由于C++使用数据类型来区分不同的异常,因此在判断异常时,throw语句中的表达式的值就没有实际意义,而表达式的类型就特别重要。

  处理除数为0的异常。该范例将上述除数为0的异常可以用try/catch语句来捕获异常,并使用throw语句来实现C++抛出异常,从而实现异常处理,实现代码如代码清单所示。

  #include<iostream.h> //包含头文件  #include<stdlib.h> double fuc(double x, double y) //定义函数

  {  if(y==0)

  {  throw y; //除数为0,抛出异常  }

  return x/y; //否则返回两个数的商  }

  void main()

  {  double res;  try //定义异常

  {  res=fuc(2,3);  cout<<"The result of x/y is : "<<res<<endl;  res=fuc(4,0); //出现异常  }

  catch(double) //捕获并处理异常

  {  cerr<<"error of dividing zero.\n";  exit(1); //异常退出程序  }

  }

  【运行结果】在Visual C++中新建一个【C++ Source File】文件,输入上述的代码,编译无误后运行。

  【范例解析】上述代码中,在主函数main()的第14~19行中使用了try语句定义异常,其中包含3条有可能出现异常的语句,它们为调用两个数相除的函数。在代码的第20~24行定义了异常处理,即捕获异常后执行该段代码中的语句。此外,在函数fuc()的代码5~8行通过throw语句实现C++抛出异常。

网友评论
精品软件课程
更多 >
Java,是由Sun Microsystem... [详细]
C语言是一种面向过程的计算机程序设计语言。多... [详细]
Visual Basic是一种由微软公司开发... [详细]
Oracle Database,又名Orac... [详细]
Visual Basic.NET是从 Vis... [详细]
Visual C++微软公司的C++开发工具... [详细]